import type { JSX } from '../../stencil-public-runtime';
import type { AlignPropType, DrawerAPI, DrawerStates, HasCloserPropType, KoliBriModalEventCallbacks, LabelPropType, OpenPropType } from '../../schema';
export declare class KolDrawer implements DrawerAPI {
    private readonly host?;
    private dialogElement?;
    private dialogWrapperElement?;
    open(): Promise<void>;
    close(): Promise<void>;
    private getWrapperRef;
    private renderDialogContent;
    private getRef;
    render(): JSX.Element;
    _open?: OpenPropType;
    _align?: AlignPropType;
    _hasCloser?: boolean;
    _label: LabelPropType;
    _on?: KoliBriModalEventCallbacks;
    state: DrawerStates;
    validateLabel(value?: LabelPropType): void;
    validateAlign(value?: AlignPropType): void;
    validateHasCloser(value?: HasCloserPropType): void;
    validateOpen(value?: OpenPropType): void;
    private openOrCloseBasedOnState;
    validateOn(value?: KoliBriModalEventCallbacks): void;
    private handleCloseDialog;
    private handleClose;
    private handleAnimationEnd;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    componentWillLoad(): void;
}
